//
// 

#include <FL/x.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl.H>
#include <FL/Fl_RGB_Image.H>
#include <FL/Fl_Tooltip.H>
#include <cstdlib>
#include <iostream>

static int wmClientMsg(Display *disp, Window win, char const *msg)
{
    XEvent event;
    long mask = SubstructureRedirectMask | SubstructureNotifyMask;

    event.xclient.type = ClientMessage;
    event.xclient.serial = 0;
    event.xclient.send_event = True;
    event.xclient.message_type = XInternAtom(disp, msg, False);
    event.xclient.window = win;
    event.xclient.format = 32;
    event.xclient.data.l[0] = 0;
    event.xclient.data.l[1] = 0;
    event.xclient.data.l[2] = 0;
    event.xclient.data.l[3] = 0;
    event.xclient.data.l[4] = 0;
    
    XSendEvent(disp, DefaultRootWindow(disp), False, mask, &event);
}/*}}}*/

// not relevant
// Fl_Check_Button *c1, *c2;

class Fl_Window_Showtest : public Fl_Window
{
  public:
   Fl_Window_Showtest(int w, int h, const char* title= 0) 
   : Fl_Window(w, h, title)
   {}
   virtual ~Fl_Window_Showtest()
   {}

   void show()
   {
     show(false);
     //Fl_Check_Button *b = (strcmp(label(), "w1")==0) ? c1 : c2;
     //show(b->value() ? true:false);
   }

   void show(bool using_ewmh) {
     image(Fl::scheme_bg_);
     if (Fl::scheme_bg_) {
       labeltype(FL_NORMAL_LABEL);
       align(FL_ALIGN_CENTER | FL_ALIGN_INSIDE | FL_ALIGN_CLIP);
     } else {
       labeltype(FL_NO_LABEL);
     }
     Fl_Tooltip::exit(this);
     std::cout << "Window:" << label() ;
     if (!shown()) {
       Fl_Window::show();
       std::cout << "(was !shown)" << std::endl;
     } else {
       if(using_ewmh) {
         std::cout << " show w EWMH" << std::endl;
         wmClientMsg(fl_display, fl_xid_(this), "_NET_ACTIVE_WINDOW");
       } else {
         std::cout << " show std" << std::endl;
       }
       XMapRaised(fl_display, fl_xid_(this));
     }
   }
};

Fl_Window_Showtest *w1, *w2;

void cb11(Fl_Widget*, void *){ w2->show(false); }
void cb12(Fl_Widget*, void *){ w2->show(true);  }
void cb21(Fl_Widget*, void *){ w1->show(false); }
void cb22(Fl_Widget*, void *){ w1->show(true);  }

int main(void) 
{
  w1=new Fl_Window_Showtest(200, 80, "w1");
  
  Fl_Button *b11=new Fl_Button(10, 10, 180, 21, "show w2 without ewmh");
  Fl_Button *b12=new Fl_Button(10, 35, 180, 21, "show w2 using ewmh");
  //c1 = new Fl_Check_Button(10, 60, 180, 21, "default show uses ewmh");
  b11->callback(cb11);
  b12->callback(cb12);
  w2=new Fl_Window_Showtest(200, 80, "w2");
  
  Fl_Button *b21=new Fl_Button(10, 10, 180, 21, "show w1 without ewmh");
  Fl_Button *b22=new Fl_Button(10, 35, 180, 21, "show w1 using ewmh");
  //c2 = new Fl_Check_Button(10, 60, 180, 21, "default show uses ewmh");
  b21->callback(cb21);
  b22->callback(cb22);
  
  w1->show();
  Fl::run();
}
